#TEMPLATE (OneInstace, 'One Instance'),Family('Cw20'),Family('ABC')
#! -------------------------------------------------------------------------- #!
#! Version       : 1
#! Thanks to Steve Parker 
#! Clarion Magazine article 
#! A Nave Look at The Mutex
#! Thanks to  Larry Sand
#! Clarionfoundry article 
#! Force an application to be displayed at the top of all other windows
#! If you find this template usefull
#! Be nice to someone
#! -------------------------------------------------------------------------- #!
#EXTENSION(OneInstace,'Limits application to one start.'),APPLICATION
#BOXED('OneInstance')
#DISPLAY('Freeware for clarion community')
#PROMPT('Window Name:',@S20),%ApplicName,REQ
#ENDBOXED

#AT(%GlobalData)
 Include('cwsynchm.inc'),once
Limiter &IMutex,auto, thread
Result Signed,auto
hwndApp   UNSIGNED
szTitle   CSTRING( '%ApplicName')
ProgramStarted Byte
#ENDAT

#AT(%GlobalMap)
MODULE('WINAPI')
    FindWindow(<*CSTRING lpClassName>, |
                    *CSTRING lpWindowName), |
                    UNSIGNED,PASCAL,RAW,NAME('FindWindowA')
    IsIconic(UNSIGNED),BOOL,PASCAL
    ShowWindow(UNSIGNED, SIGNED nCmdShow),BOOL,PASCAL,PROC
    SetForegroundWindow(UNSIGNED),BOOL,PASCAL,PROC
End
#ENDAT


#AT(%ProgramEnd)
If ProgramStarted
  Limiter.Release()
  Limiter.Kill()
End
#ENDAT

#AT(%ProgramSetup)
Limiter &= NewMutex('thisApp')

If Limiter &= NULL
  Message('Error: Mutex cannot be created')
  Return
Else
  Result = Limiter.TryWait(50)
  If Result <= WAIT:Ok
    ProgramStarted = True
   Elsif Result = WAIT:TIMEOUT
    hwndApp = FindWindow(, szTitle)
    IF hwndApp
     IF IsIconic(hwndApp)
       ShowWindow(hwndApp, 1)
     ELSE
       SetForegroundWindow(hwndApp)
     END
    END
    Return
  Else
    Message('Wait failed')
    Return
  End
End


#ENDAT

#!-------------------------------------------------------------------------------